''-----------------------------------------------------------------------------
''     ""  1.48
''      :
''  :   () E-Mail AT_Marat@list.net
''-----------------------------------------------------------------------------
#Ifndef _SQUALL_H_INCLUDED_
#define _SQUALL_H_INCLUDED_
#EndIf

Extern "C"

#define IsTrue(r) IIf(r >= 0 , -1 , 0)
#define IsFalse(r) IIf(r < 0 , -1 , 0)

''  
#define  SQUALL_ERROR_NO_SOUND               -1    '     
#define  SQUALL_ERROR_MEMORY                 -2    '   
#define  SQUALL_ERROR_UNINITIALIZED          -3    '   
#define  SQUALL_ERROR_INVALID_PARAM          -4    '    
#define  SQUALL_ERROR_CREATE_WINDOW          -5    '    
#define  SQUALL_ERROR_CREATE_DIRECT_SOUND    -6    '    DirectSound 
#define  SQUALL_ERROR_CREATE_THREAD          -7    '   
#define  SQUALL_ERROR_SET_LISTENER_PARAM     -8    '    
#define  SQUALL_ERROR_GET_LISTENER_PARAM     -9    '    
#define  SQUALL_ERROR_NO_FREE_CHANNEL        -10   '      
#define  SQUALL_ERROR_CREATE_CHANNEL         -11   '   3   
#define  SQUALL_ERROR_CHANNEL_NOT_FOUND      -12   '   3   
#define  SQUALL_ERROR_SET_CHANNEL_PARAM      -13   '    
#define  SQUALL_ERROR_GET_CHANNEL_PARAM      -14   '     
#define  SQUALL_ERROR_METHOD                 -15   '     
#define  SQUALL_ERROR_ALGORITHM              -16   '  3D   
#define  SQUALL_ERROR_NO_EAX                 -17   '  EAX  
#define  SQUALL_ERROR_EAX_VERSION            -18   '   EAX  
#define  SQUALL_ERROR_SET_EAX_PARAM          -19   '   EAX  
#define  SQUALL_ERROR_GET_EAX_PARAM          -20   '   EAX  
#define  SQUALL_ERROR_NO_ZOOMFX              -21   '  ZOOMFX  
#define  SQUALL_ERROR_SET_ZOOMFX_PARAM       -22   '   ZOOMFX  
#define  SQUALL_ERROR_GET_ZOOMFX_PARAM       -23   '   ZOOMFX  
#define  SQUALL_ERROR_UNKNOWN                -24   '  
#define  SQUALL_ERROR_SAMPLE_INIT            -25   '    
#define  SQUALL_ERROR_SAMPLE_BAD             -26   '  
#define  SQUALL_ERROR_SET_MIXER_PARAM        -27   '    
#define  SQUALL_ERROR_GET_MIXER_PARAM        -28   '    

'  
#define SQUALL_LISTENER_MODE_IMMEDIATE 0           '   
#define SQUALL_LISTENER_MODE_DEFERRED  1           '       Listener_Update

'       
#define SQUALL_ALG_3D_DEFAULT          0           '   
#define SQUALL_ALG_3D_OFF              1           ' 2D 
#define SQUALL_ALG_3D_FULL             2           '  3D 
#define SQUALL_ALG_3D_LIGTH            3           '  3D 

'      

Type squall_callback_open_t As Function Cdecl (name_ As ZString Ptr) As UInteger
Type squall_callback_read_t As Function Cdecl (Handle As UInteger, Buffer As Any Ptr, Size As Integer) As Integer
Type squall_callback_seek_t As Function Cdecl (Handle As UInteger, Position As Integer, SeekMode As Integer) As Integer
Type squall_callback_close_t As Sub Cdecl (Handle As UInteger)


'      
'typedef void*        (__cdecl* squall_callback_alloc_t)     (unsigned int Size);
'typedef void         (__cdecl* squall_callback_free_t)      (void* Ptr);

Type squall_callback_alloc_t As Function Cdecl (Size As UInteger) As Any Ptr
Type squall_callback_free_t As Sub( As Any Ptr)

'     
Type squall_callback_listener_t As Sub  Cdecl (UserData As Any Ptr)
Type squall_callback_channel_t As Function Cdecl (ChannelID As Integer,UserData As Any Ptr) As Integer
Type squall_callback_end_channel_t As Function Cdecl (ChannelID As Integer,UserData As Any Ptr) As Integer

'     
Type squall_parameters_t
	As Any Ptr   Window                                  '      
	As Integer     Device                                '   
	As Integer     SampleRate                            '  
	As Integer     BitPerSample                          '    
	As Integer     Channels                              '   
	As Integer     UseHW2D                               '      
	As Integer     UseHW3D                               '      
	As Integer     UseAlg                                '   
	As Integer     BufferSize                            '     
	As Integer     ListenerMode                          '       
	As Single   DistanceFactor                           '  
	As Single   RolloffFactor                            '  
	As Single   DopplerFactor                            '  
End Type

'      
Type squall_sample_default_t
	As Integer     SampleGroupID                         '    
	As Integer     Priority                              '    
	As Integer     Frequency                             '    
	As Integer     Volume                                '    
	As Integer     Pan                                   '    
	As Single   MinDist                                  '     
	As Single   MaxDist                                  '     
End Type

'     
Type squall_channels_t
	As Integer     Play                                  '    
	As Integer     Pause                                 '      
	As Integer     Prepare                               '    
	As Integer     Play3D                                '    
	As Integer     Pause3D                               '      
	As Integer     Prepare3D                             '    
End Type

'     
Type squall_device_caps_t
	As Integer     Flags                                 '    
	As Integer     HardwareChannels                      '   
	As Integer     Hardware3DChannels                    '   3D 
End Type

'     
#define SQUALL_DEVICE_CAPS_HARDWARE    &h00000001  '     
#define SQUALL_DEVICE_CAPS_HARDWARE_3D &h00000002  '     3D 
#define SQUALL_DEVICE_CAPS_EAX10       &h00000004  '   EAX 1.0
#define SQUALL_DEVICE_CAPS_EAX20       &h00000008  '   EAX 2.0
#define SQUALL_DEVICE_CAPS_EAX30       &h00000010  '   EAX 3.0
#define SQUALL_DEVICE_CAPS_ZOOMFX      &h00000100  '   ZOOMFX

'    
#define SQUALL_SPEAKER_DEFAULT         &h00000000  '   
#define SQUALL_SPEAKER_HEADPHONE       &h00000001  '  ( )
#define SQUALL_SPEAKER_MONO            &h00000002  '   (1.0)
#define SQUALL_SPEAKER_STEREO          &h00000003  '   (2.0)
#define SQUALL_SPEAKER_QUAD            &h00000004  '   (4.0)
#define SQUALL_SPEAKER_SURROUND        &h00000005  '       (4.1)
#define SQUALL_SPEAKER_5POINT1         &h00000006  '        (5.1)

'  
#define SQUALL_CHANNEL_STATUS_NONE     0           '  
#define SQUALL_CHANNEL_STATUS_PLAY     1           '    
#define SQUALL_CHANNEL_STATUS_PAUSE    2           '    
#define SQUALL_CHANNEL_STATUS_PREPARED 3           '    

'   EAX 
Union squall_eax_listener_t
'  EAX 1.0
Type
	As UInteger       Environment
	As Single         Volume
	As Single         DecayTime_sec
	As Single         Damping
End Type

'  EAX 2.0
Type
	As Integer         Room
	As Integer         RoomHF
	As Single          RoomRolloffFactor
	As Single          DecayTime
	As Single          DecayHFRatio
	As Integer         Reflections
	As Single          ReflectionsDelay
	As Integer         Reverb
	As Single          ReverbDelay
	As UInteger        Environment2
	As Single          EnvironmentSize
	As Single          EnvironmentDiffusion
	As Single          AirAbsorptionHF
	As UInteger        Flags
End Type

'  EAX 3.0
Type
	As UInteger        Environment3
	As Single          EnvironmentSize2
	As Single          EnvironmentDiffusion2
	As Integer         Room2
	As Integer         RoomHF2
	As Integer         RoomLF
	As Single          DecayTime2
	As Single          DecayHFRatio2
	As Single          DecayLFRatio
	As Integer         Reflections2
	As Single          ReflectionsDelay2
	As Single          ReflectionsPan(3)
	As Single          Reverb2
	As Single          ReverbDelay2
	As Single          ReverbPan(3)
	As Single          EchoTime
	As Single          EchoDepth
	As Single          ModulationTime
	As Single          ModulationDepth
	As Single          AirAbsorptionHF2
	As Single          HFReference
	As Single          LFReference
	As Single          RoomRolloffFactor2
	As UInteger            Flags2
End Type
End Union

'     EAX    2.0
#define SQUALL_EAX_LISTENER_FLAGS_DECAYTIMESCALE          &h00000001
#define SQUALL_EAX_LISTENER_FLAGS_REFLECTIONSSCALE        &h00000002
#define SQUALL_EAX_LISTENER_FLAGS_REFLECTIONSDELAYSCALE   &h00000004
#define SQUALL_EAX_LISTENER_FLAGS_REVERBSCALE             &h00000008
#define SQUALL_EAX_LISTENER_FLAGS_REVERBDELAYSCALE        &h00000010
#define SQUALL_EAX_LISTENER_FLAGS_DECAYHFLIMIT            &h00000020

'     EAX   3.0
#define SQUALL_EAX_LISTENER_FLAGS_ECHOTIMESCALE           &h00000040
#define SQUALL_EAX_LISTENER_FLAGS_MODULATIONTIMESCALE     &h00000080

'     EAX    2.0  
#define SQUALL_EAX_LISTENER_FLAGS_DEFAULT                 ( SQUALL_EAX_LISTENER_FLAGS_DECAYTIMESCALE          +   _
SQUALL_EAX_LISTENER_FLAGS_REFLECTIONSSCALE        +   _
SQUALL_EAX_LISTENER_FLAGS_REFLECTIONSDELAYSCALE   +   _
SQUALL_EAX_LISTENER_FLAGS_REVERBSCALE             +   _
SQUALL_EAX_LISTENER_FLAGS_REVERBDELAYSCALE        +   _
SQUALL_EAX_LISTENER_FLAGS_DECAYHFLIMIT    )

'    EAX 
#define SQUALL_EAX_OFF              -1
#define SQUALL_EAX_GENERIC           0
#define SQUALL_EAX_PADDEDCELL        1
#define SQUALL_EAX_ROOM              2
#define SQUALL_EAX_BATHROOM          3
#define SQUALL_EAX_LIVINGROOM        4
#define SQUALL_EAX_STONEROOM         5
#define SQUALL_EAX_AUDITORIUM        6
#define SQUALL_EAX_CONCERTHALL       7
#define SQUALL_EAX_CAVE              8
#define SQUALL_EAX_ARENA             9
#define SQUALL_EAX_HANGAR           10
#define SQUALL_EAX_CARPETEDHALLWAY  11
#define SQUALL_EAX_HALLWAY          12
#define SQUALL_EAX_STONECORRIDOR    13
#define SQUALL_EAX_ALLEY            14
#define SQUALL_EAX_FOREST           15
#define SQUALL_EAX_CITY             16
#define SQUALL_EAX_MOUNTAINS        17
#define SQUALL_EAX_QUARRY           18
#define SQUALL_EAX_PLAIN            19
#define SQUALL_EAX_PARKINGLOT       20
#define SQUALL_EAX_SEWERPIPE        21
#define SQUALL_EAX_UNDERWATER       22
#define SQUALL_EAX_DRUGGED          23
#define SQUALL_EAX_DIZZY            24
#define SQUALL_EAX_PSYCHOTIC        25

' C EAX  
Union squall_eax_channel_t

' EAX 1.0
Type
	As Single              Mix
End Type

' EAX 2.0
Type
	As Integer              Direct
	As Integer              DirectHF
	As Integer              Room
	As Integer              RoomHF
	As Single               RoomRolloffFactor
	As Integer              Obstruction
	As Single               ObstructionLFRatio
	As Integer              Occlusion
	As Single               OcclusionLFRatio
	As Single               OcclusionRoomRatio
	As Integer              OutsideVolumeHF
	As Single               AirAbsorptionFactor
	As UInteger                 Flags
End Type

'  EAX 3.0
Type
	As Integer                Direct2
	As Integer                DirectHF2
	As Integer                Room2
	As Integer                RoomHF2
	As Integer                Obstruction2
	As Single                 ObstructionLFRatio2
	As Integer                Occlusion2
	As Single                 OcclusionLFRatio2
	As Single                 OcclusionRoomRatio2
	As Single                 OcclusionDirectRatio
	As Integer                Exclusion
	As Single                 ExclusionLFRatio
	As Integer                OutsideVolumeHF2
	As Single                 DopplerFactor
	As Single                 RolloffFactor
	As Single                 RoomRolloffFactor2
	As Single                 AirAbsorptionFactor2
	As UInteger               Flags2
End Type
End Union

'     EAX    2.0
#define SQUALL_EAX_CHANNEL_FLAGS_DIRECTHFAUTO             &h00000001
#define SQUALL_EAX_CHANNEL_FLAGS_ROOMAUTO                 &h00000002
#define SQUALL_EAX_CHANNEL_FLAGS_ROOMHFAUTO               &h00000004
#define SQUALL_EAX_CHANNEL_FLAGS_DEFAULT                  (SQUALL_EAX_CHANNEL_FLAGS_DIRECTHFAUTO +   _
SQUALL_EAX_CHANNEL_FLAGS_ROOMAUTO     +  _
SQUALL_EAX_CHANNEL_FLAGS_ROOMHFAUTO   )
'  ZOOMFX   
Type squall_zoomfx_channel_t
	As Single    Min_(3)
	As Single    Max_(3)
	As Single    Front(3)
	As Single    Top(3)
	As Integer     MacroFX
End Type


'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                   / 
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'    
'      :  SystemParam -      
'                                  .
'                                   0  
'                                   
'                                :
'                               Window         = 0     (  )
'                               Device         = 0     (  )
'                               SampleRate     = 44100
'                               BitPerSample   = 16
'                               Channels       = 16
'                               UseHW2D        = true  ()
'                               UseHW3D        = true  ()
'                               UseAlg         = 0     (  )
'                               BufferSize     = 200
'                               ListenerMode   = 0     ( )
'                               DistanceFactor = 1.0f
'                               RolloffFactor  = 1.0f
'                               DopplerFactor  = 1.0f
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Init Lib "Squall" Alias "SQUALL_Init"(SystemParam As squall_parameters_t Ptr) As Integer

'-----------------------------------------------------------------------------
'     
'      :  *
'     :  *
'-----------------------------------------------------------------------------
Declare Sub SQUALL_Free Lib "Squall" Alias "SQUALL_Free" ()

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                     
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
' /    
'      :  Pause -   / 
'                             
'                         true  -  
'                         false -  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_Pause Lib "Squall" Alias "SQUALL_Pause" (pause_ As Integer) As Integer

'-----------------------------------------------------------------------------
'    
'      :  *
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_Stop Lib "Squall" Alias "SQUALL_Stop" () As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                       
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'    
'      :  Num   -     , 
'                               0  
'                             SQUALL_GetNumDevice.
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_SetDevice Lib "Squall" Alias "SQUALL_SetDevice" (num As Integer) As Integer

'-----------------------------------------------------------------------------
'     
'      :  *
'     :  ,       0,
'                 ,     
'                       
'                 
'-----------------------------------------------------------------------------

Declare Function SQUALL_GetDevice Lib "Squall" Alias "SQUALL_GetDevice"() As Integer

'-----------------------------------------------------------------------------
' /    
'      :  UseHW2D  -     
'                               ,
'                                :
'                            true   -   
'                            false  -    
'                UseHW3D  -     
'                               
'                                :
'                            true   -   
'                            false  -    
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_SetHardwareAcceleration Lib "Squall" Alias "SQUALL_SetHardwareAcceleration" (UseHW2D As Integer, UseHW3D As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  UseHW2D  -        
'                               
'                                
'                UseHW3D  -        
'                               
'                                
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_GetHardwareAcceleration Lib "Squall" Alias "SQUALL_GetHardwareAcceleration" (UseHW2D As Integer Ptr, UseHW3D As Integer Ptr) As Integer
'-----------------------------------------------------------------------------
'   
'      :  Mode  -   ,   
'                          :
'                         SQUALL_SPEAKER_DEFAULT   -   
'                         SQUALL_SPEAKER_HEADPHONE -  ( )
'                         SQUALL_SPEAKER_MONO      -   (1.0)
'                         SQUALL_SPEAKER_STEREO    -   (2.0)
'                         SQUALL_SPEAKER_QUAD      -   (4.0)
'                         SQUALL_SPEAKER_SURROUND  -    
'                                                      (4.1)
'                         SQUALL_SPEAKER_5POINT1   -    
'                                                       (5.1)
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_SetSpeakerMode Lib "Squall"  Alias "SQUALL_SetSpeakerMode" (mode As Integer) As Integer

'-----------------------------------------------------------------------------
'	   
'	     :  *
'     :  ,       0,
'                 ,     
'                       
'                 
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetSpeakerMode Lib "Squall"  Alias "SQUALL_GetSpeakerMode" () As Integer

'-----------------------------------------------------------------------------
'     
'      :  Algoritm -      
'                                :
'                            SQUALL_ALG_3D_DEFAULT -   
'                            SQUALL_ALG_3D_OFF     - 2D 
'                            SQUALL_ALG_3D_FULL    -  3D 
'                            SQUALL_ALG_3D_LIGTH   -  3D 
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------

Declare Function SQUALL_Set3DAlgorithm Lib "Squall"  Alias "SQUALL_Set3DAlgorithm" (Algorithm As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  *
'     :  ,       0,
'                 ,     
'                       
'                   ,  
'                  :
'                SQUALL_ALG_3D_DEFAULT -   
'                SQUALL_ALG_3D_OFF     - 2D 
'                SQUALL_ALG_3D_FULL    -  3D 
'                SQUALL_ALG_3D_LIGTH   -  3D 
'-----------------------------------------------------------------------------
Declare Function SQUALL_Get3DAlgorithm Lib "Squall"  Alias "SQUALL_Get3DAlgorithm" () As Integer

'-----------------------------------------------------------------------------
'       
'      :  BufferSize  -     ,  
'                                     200
'                                5000
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_SetBufferSize Lib "Squall"  Alias "SQUALL_SetBufferSize" (BufferSize As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  *
'     :  ,       0,
'                 ,     
'                       
'                   
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetBufferSize Lib "Squall"  Alias "SQUALL_GetBufferSize" () As Integer

'-----------------------------------------------------------------------------
'      
'      :  UserAlloc   -       
'                UserFree    -       
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_SetMemoryCallbacks Lib "Squall"  Alias "SQUALL_SetMemoryCallbacks" (UserAlloc As squall_callback_alloc_t,UserFree As squall_callback_free_t) As Integer

'-----------------------------------------------------------------------------
'       
'      :  UserOpen    -       
'                UserSeek    -      
'                                 
'                UserRead    -        
'                                
'                UserClose   -       
'                               
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_SetFileCallbacks Lib "Squall"  Alias "SQUALL_SetFileCallbacks" (UserOpen As squall_callback_open_t , UserSeek As squall_callback_seek_t ,UserRead As squall_callback_read_t , UserClose As squall_callback_close_t ) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                   
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'     
'      :  *
'     :  ,       0,
'                 ,     .
'                      
'                   .    
'                     0.
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetNumDevice Lib "Squall"  Alias "SQUALL_GetNumDevice" () As Integer

'-----------------------------------------------------------------------------
'      
'      :  Num      -   ,    
'                               0     
'                             SQUALL_GetNumDevice.
'                Buffer   -        
'                             
'                Size     -      
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetDeviceName Lib "Squall"  Alias "SQUALL_GetDeviceName" (Num As Integer, Buffer As ZString Ptr, Size As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  Num   -   ,     
'                           0     
'                          SQUALL_GetNumDevice.
'                Caps  -        
'                           
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetDeviceCaps Lib "Squall"  Alias "SQUALL_GetDeviceCaps" (Num As Integer, Caps As squall_device_caps_t Ptr) As Integer
'-----------------------------------------------------------------------------
'    EAX 
'      :  *
'     :  ,       0,
'                 ,     
'                      
'                  EAX
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetEAXVersion Lib "Squall"  Alias "SQUALL_GetEAXVersion" () As Integer

'-----------------------------------------------------------------------------
'    
'      :  Info  -        
'                            
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_GetChannelsInfo Lib "Squall"  Alias "SQUALL_GetChannelsInfo" (Info As squall_channels_t Ptr) As Integer


'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                        
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'    
'      :  Position -       
'                             .     
'                              ,    
'                             0
'                Front    -       
'                              .   
'                                
'                             ,      0
'                Top      -       
'                              .   
'                                 ,
'                                 0
'                Velocity -       
'                              .   
'                                 ,
'                                 0.
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetParameters Lib "Squall"  Alias "SQUALL_Listener_SetParameters" (Position As Single Ptr, Front As Single Ptr, Top As Single Ptr, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'    
'      :  Position -       
'                               .  
'                                 
'                            ,      0.
'                Front    -       
'                               
'                             .    
'                                
'                            ,      0.
'                Top      -       
'                               
'                             .    
'                                
'                            ,      0.
'                Velocity -       
'                                
'                            .     
'                               ,  
'                               0.
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetParameters Lib "Squall"  Alias "SQUALL_Listener_GetParameters" (Position As Single Ptr, Front As Single Ptr, Top As Single Ptr, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     
'      :  Velocity -       
'                              .
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetVelocity Lib "Squall"  Alias "SQUALL_Listener_SetVelocity" (Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     
'      :  Velocity -      
'                               
'                           .
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetVelocity Lib "Squall"  Alias "SQUALL_Listener_GetVelocity" (Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  Position -       
'                              .
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetPosition Lib "Squall"  Alias "SQUALL_Listener_SetPosition" (Position As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  Position -       
'                                
'                            .
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetPosition Lib "Squall"  Alias "SQUALL_Listener_GetPosition" (Position As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     
'      :  DistanceFactor -     
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetDistanceFactor Lib "Squall"  Alias "SQUALL_Listener_SetDistanceFactor" (DistanceFactor As Single) As Integer

'-----------------------------------------------------------------------------
'     
'      :  DistanceFactor -       
'                                    
'                                   
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetDistanceFactor Lib "Squall"  Alias "SQUALL_Listener_GetDistanceFactor" (DistanceFactor As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'         
'      :  RolloffFactor  -     
'                                  ,     
'                                     0.1f  10.0f
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetRolloffFactor Lib "Squall"  Alias "SQUALL_Listener_SetRolloffFactor" (RolloffFactor As Single) As Integer

'-----------------------------------------------------------------------------
'         
'      :  RolloffFactor  -       
'                                     
'                                   
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetRolloffFactor Lib "Squall"  Alias "SQUALL_Listener_GetRolloffFactor" (RolloffFactor As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     
'      :  DopplerFactor  -     , 
'                                        0.1f
'                                   10.0f
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetDopplerFactor Lib "Squall"  Alias "SQUALL_Listener_SetDopplerFactor" (DopplerFactor As Single) As Integer

'-----------------------------------------------------------------------------
'     
'      :  DopplerFactor  -       
'                                     
'                                  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_GetDopplerFactor Lib "Squall"  Alias "SQUALL_Listener_GetDopplerFactor" (DopplerFactor As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'   
'      :  *
'     :  ,       0,
'                 ,     
'   :           
'                     
'                .      
'                   SQUALL_LISTENER_MODE_DEFERRED
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_Update Lib "Squall"  Alias "SQUALL_Listener_Update" () As Integer

'-----------------------------------------------------------------------------
'    
'      :  Preset   -    
'                                :
'                            SQUALL_EAX_OFF
'                            SQUALL_EAX_GENERIC
'                            SQUALL_EAX_PADDEDCELL
'                            SQUALL_EAX_ROOM
'                            SQUALL_EAX_BATHROOM
'                            SQUALL_EAX_LIVINGROOM
'                            SQUALL_EAX_STONEROOM
'                            SQUALL_EAX_AUDITORIUM
'                            SQUALL_EAX_CONCERTHALL
'                            SQUALL_EAX_CAVE
'                            SQUALL_EAX_ARENA
'                            SQUALL_EAX_HANGAR
'                            SQUALL_EAX_CARPETEDHALLWAY
'                            SQUALL_EAX_HALLWAY
'                            SQUALL_EAX_STONECORRIDOR
'                            SQUALL_EAX_ALLEY
'                            SQUALL_EAX_FOREST
'                            SQUALL_EAX_CITY
'                            SQUALL_EAX_MOUNTAINS
'                            SQUALL_EAX_QUARRY
'                            SQUALL_EAX_PLAIN
'                            SQUALL_EAX_PARKINGLOT
'                            SQUALL_EAX_SEWERPIPE
'                            SQUALL_EAX_UNDERWATER
'                            SQUALL_EAX_DRUGGED
'                            SQUALL_EAX_DIZZY
'                            SQUALL_EAX_PSYCHOTIC
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_EAX_SetPreset Lib "Squall"  Alias "SQUALL_Listener_EAX_SetPreset" (Preset_ As Integer) As Integer

'-----------------------------------------------------------------------------
'   EAX  
'      :  Version     -    EAX 
'                Properties  -       EAX 
'                               
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_EAX_SetProperties Lib "Squall"  Alias "SQUALL_Listener_EAX_SetProperties" (Version As Integer, Properties As squall_eax_listener_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   EAX  
'      :  Version     -    EAX 
'                Properties  -       
'                                EAX  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_EAX_GetProperties Lib "Squall"  Alias "SQUALL_Listener_EAX_GetProperties" (Version As Integer, Properties As squall_eax_listener_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   
'      :  Worker      -     ,  
'                                  0,  
'                                .
'                Param       -     ,  
'                                 ,   
'                                 0
'                UpdateTime  -      
'                                   
'                                  1  5000
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Listener_SetWorker Lib "Squall"  Alias "SQUALL_Listener_SetWorker" ( Worker As squall_callback_listener_t, Param As Any Ptr, UpdateTime As UInteger) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                        
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Start Lib "Squall"  Alias "SQUALL_Channel_Start" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
' /   
'      :  ChannelID   -    
'                Pause       -   / ,  
'                                 :
'                               true  -  
'                               false -  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Pause Lib "Squall"  Alias "SQUALL_Channel_Pause" (ChannelID As Integer, Pause_ As Integer) As Integer

'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Stop Lib "Squall"  Alias "SQUALL_Channel_Stop" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'    
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       ,
'                    :
'                SQUALL_CHANNEL_STATUS_NONE       -     
'                                                     
'                SQUALL_CHANNEL_STATUS_PLAY       -   
'                                                    
'                SQUALL_CHANNEL_STATUS_PAUSE      -    
'                                                      
'                SQUALL_CHANNEL_STATUS_PREPARED   -   
'                                                    
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Status Lib "Squall"  Alias "SQUALL_Channel_Status" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Volume      -      ,
'                                    
'                                0  100
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetVolume Lib "Squall"  Alias "SQUALL_Channel_SetVolume" (ChannelID As Integer, Volume As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -   
'     :  ,       0,
'                 ,     
'                       
'                   
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetVolume Lib "Squall"  Alias "SQUALL_Channel_GetVolume" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID   -    
'                Frequency   -     , 
'                                     100 
'                                1000000 
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetFrequency Lib "Squall"  Alias "SQUALL_Channel_SetFrequency" (ChannelID As Integer, Frequency As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       
'                   
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetFrequency Lib "Squall"  Alias "SQUALL_Channel_GetFrequency" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Position    -     
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetPlayPosition Lib "Squall"  Alias "SQUALL_Channel_SetPlayPosition" (ChannelID As Integer, Position As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       
'                
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetPlayPosition Lib "Squall"  Alias "SQUALL_Channel_GetPlayPosition" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Position    -     ,
'                                
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetPlayPositionMs Lib "Squall"  Alias "SQUALL_Channel_SetPlayPositionMs" (ChannelID As Integer, Position As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       
'                
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetPlayPositionMs Lib "Squall"  Alias "SQUALL_Channel_GetPlayPositionMs" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'    
'      :  ChannelID   -    
'                Worker      -      
'                Param       -     ,  
'                                  ,  
'                                0
'                UpdateTime  -      
'                                  , 
'                                     1  5000
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetWorker Lib "Squall"  Alias "SQUALL_Channel_SetWorker" (ChannelID As Integer, Worker As squall_callback_channel_t , UpdateTime As UInteger) As Integer

'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'                Worker      -      
'                Param       -     ,  
'                                  ,  
'                                0
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetEndWorker Lib "Squall"  Alias "SQUALL_Channel_SetEndWorker" (ChannelID As Integer, Worker As squall_callback_end_channel_t , param As Any Ptr) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Start       -    ,  
'                End         -    ,  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetFragment Lib "Squall"  Alias "SQUALL_Channel_SetFragment" (ChannelID As Integer, start As Integer , end_ As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Start       -       
'                                   
'                               
'                End         -       
'                                  
'                                
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetFragment Lib "Squall"  Alias "SQUALL_Channel_GetFragment" (ChannelID As Integer, start As Integer Ptr, end_ As Integer Ptr) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Start       -    ,  
'                               
'                End         -    ,  
'                               
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetFragmentMs Lib "Squall"  Alias "SQUALL_Channel_SetFragmentMs" (ChannelID As Integer, start As Integer , end_ As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Start       -       
'                                  
'                                
'                End         -       
'                                  
'                                
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetFragmentMs Lib "Squall"  Alias "SQUALL_Channel_GetFragmentMs" (ChannelID As Integer, start As Integer Ptr, end_ As Integer Ptr) As Integer

'-----------------------------------------------------------------------------
'       
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                      
'                   
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetLength Lib "Squall"  Alias "SQUALL_Channel_GetLength" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                      
'                   
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetLengthMs Lib "Squall"  Alias "SQUALL_Channel_GetLengthMs" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'                Priority    -    ,  
'                                    0 ( 
'                               )  65535 (  )
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetPriority Lib "Squall"  Alias "SQUALL_Channel_SetPriority" (ChannelID As Integer, Priority As Integer) As Integer

'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                      
'                 
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetPriority Lib "Squall"  Alias "SQUALL_Channel_GetPriority" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'       
' 
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       
'                   ,  
'                  :
'                true  -     
'                false -      
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetLoop Lib "Squall"  Alias "SQUALL_Channel_GetLoop" (ChannelID As Integer) As Integer

'-----------------------------------------------------------------------------
'       
' 
'      :  ChannelID   -    
'                Loop        -    ,  
'                                  :
'                               true  -    
'                                        
'                               false -     
'                                        
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetLoop Lib "Squall"  Alias "SQUALL_Channel_SetLoop" (ChannelID As Integer, loop_ As Integer) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                     
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'                Pan         -    ,  
'                                    0 (
'                                  )  100
'                               (    )
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetPan Lib "Squall"  Alias "SQUALL_Channel_SetPan" (ChannelID As Integer, Pan As Integer) As Integer

'-----------------------------------------------------------------------------
'     
'      :  ChannelID   -    
'     :  ,       0,
'                 ,     
'                       
'                 
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetPan Lib "Squall"  Alias "SQUALL_Channel_GetPan" (ChannelID As Integer) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                     
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Position    -       
'                                 
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Set3DPosition Lib "Squall"  Alias "SQUALL_Channel_Set3DPosition" (ChannelID As Integer, Position As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'        
'      :  ChannelID   -    
'                Position    -       
'                                   
'                                 
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_Get3DPosition Lib "Squall"  Alias "SQUALL_Channel_Get3DPosition" (ChannelID As Integer, Position As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID   -    
'                Velocity    -       
'                                  
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetVelocity Lib "Squall"  Alias "SQUALL_Channel_SetVelocity" (ChannelID As Integer, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID   -    
'                Velocity    -       
'                                   
'                                
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetVelocity Lib "Squall"  Alias "SQUALL_Channel_GetVelocity" (ChannelID As Integer, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'       
'  
'      :  ChannelID   -    
'                MinDist     -     
'                                    
'                                0.01f  1000000000.0f
'                MaxDist     -     
'                                    
'                                0.01f  1000000000.0f
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetMinMaxDistance Lib "Squall"  Alias "SQUALL_Channel_SetMinMaxDistance" (ChannelID As Integer, MinDist As Single, MaxDist As Single) As Integer

'-----------------------------------------------------------------------------
'       
'      :  ChannelID   -    
'                MinDist     -       
'                                  
'                               
'                MinDist     -       
'                                  
'                               
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetMinMaxDistance Lib "Squall"  Alias "SQUALL_Channel_GetMinMaxDistance" (ChannelID As Integer, MinDist As Single Ptr, MaxDist As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID         -    
'                Orientation       -      
'                                         ,
'                                          
'                                         
'                                      ,    
'                                      0
'                InsideConeAngle   -     , 
'                                           1 
'                                     360 ,    
'                                         
'                                      ,    
'                                      0
'                OutsideConeAngle  -     , 
'                                           1 
'                                     360 ,    
'                                         
'                                      ,    
'                                      0
'                OutsideVolume     -      
'                                      ,   
'                                           0
'                                      100
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_SetConeParameters Lib "Squall"  Alias "SQUALL_Channel_SetConeParameters" (ChannelID As Integer, Orientation As Single Ptr, InsideConeAngle As Integer, OutsideConeAngle As Integer, OutsideVolume As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelID         -    
'                Orientation       -       
'                                        
'                                        ,  
'                                        
'                                       ,   ,
'                                          0
'                InsideConeAngle   -       
'                                         
'                                       ,    
'                                          ,
'                                          0
'                OutsideConeAngle  -       
'                                         
'                                       ,    
'                                          ,
'                                          0
'                OutsideVolume     -       
'                                         
'                                         , 
'                                     ,     
'                                         
'                                       ,   
'                                       0
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_GetConeParameters Lib "Squall"  Alias "SQUALL_Channel_GetConeParameters" (ChannelID As Integer, Orientation As Single Ptr, InsideConeAngle As Integer Ptr, OutsideConeAngle As Integer Ptr, OutsideVolume As Integer Ptr) As Integer

'-----------------------------------------------------------------------------
'   EAX   
'      :  ChannelID   -    
'                Version     -    EAX,    
'                                 EAX  .
'                Properties  -      
'                               EAX ,     
'                                 Version
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_EAX_SetProperties Lib "Squall"  Alias "SQUALL_Channel_EAX_SetProperties" (ChannelID As Integer, Version As Integer, Property_ As squall_eax_channel_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   EAX   
'      :  ChannelID   -    
'                Version     -    EAX,    
'                                 EAX  .
'                Properties  -       
'                                 EAX ,  
'                                   
'                                Version
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_EAX_GetProperties Lib "Squall"  Alias "SQUALL_Channel_EAX_GetProperties" (ChannelID As Integer, Version As Integer, Property_ As squall_eax_channel_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   ZOOMFX   
'      :  ChannelID   -    
'                Properties  -      
'                               ZOOMFX 
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_ZOOMFX_SetProperties Lib "Squall"  Alias "SQUALL_Channel_ZOOMFX_SetProperties" (ChannelID As Integer, Property_ As squall_zoomfx_channel_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   ZOOMFX   
'      :  ChannelID   -    
'                Properties  -       
'                                 ZOOMFX 
'     :  ,       0,
'                 ,     
'   :        
'-----------------------------------------------------------------------------
Declare Function SQUALL_Channel_ZOOMFX_GetProperties Lib "Squall"  Alias "SQUALL_Channel_ZOOMFX_GetProperties" (ChannelID As Integer, Property_ As squall_zoomfx_channel_t Ptr) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                     
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
' /   
'      :  ChannelGroupID -    
'                Pause          -   / , 
'                                     :
'                                  true  -   
'                                  false -   
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_ChannelGroup_Pause Lib "Squall"  Alias "SQUALL_ChannelGroup_Pause" (ChannelGroupID As Integer, Pause_ As Integer) As Integer

'-----------------------------------------------------------------------------
'   
'      :  ChannelGroupID -    
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_ChannelGroup_Stop Lib "Squall"  Alias "SQUALL_ChannelGroup_Stop" (ChannelGroupID As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  ChannelGroupID -    
'                Volume         -    ,  
'                                      0  100
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_ChannelGroup_SetVolume Lib "Squall"  Alias "SQUALL_ChannelGroup_SetVolume" (ChannelGroupID As Integer, Volume As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  ChannelGroupID -    
'                Frequency      -     ,
'                                       
'                                   100  1000000 
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_ChannelGroup_SetFrequency Lib "Squall"  Alias "SQUALL_ChannelGroup_SetFrequency" (ChannelGroupID As Integer, Frequency As Integer) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                    
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'    
'      :  FileName -    
'                MemFlag  -    , 
'                              :
'                           true  -       
'                           false -       
'                Default  -      
'                           ,    0, 
'                                :
'                           SampleGroupID - 0
'                           Priority      - 0
'                           Frequency     - 0
'                           Volume        - 100
'                           Pan           - 50
'                           MinDist       - 1.0f
'                           MaxDist       - 1000000000.0f
'     :  ,       0,
'                 ,     
'                      
'                 
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_LoadFile Lib "Squall"  Alias "SQUALL_Sample_LoadFile" (FileName As ZString Ptr, MemFlag As Integer, Default As squall_sample_default_t Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'   :  MemoryPtr   -      
'             MemorySize  -     
'             NewMemory   -     
'                           true -       , 
'                                         
'                                        MemoryPtr.
'                                         
'                           false -     , 
'                                         
'             Default     -      
'                           ,    0, 
'                                :
'                           SampleGroupID - 0
'                           Priority      - 0
'                           Frequency     - 0
'                           Volume        - 100
'                           Pan           - 50
'                           MinDist       - 1.0f
'                           MaxDist       - 1000000000.0f
'     :  ,       0,
'                 ,     
'                      
'                 
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_LoadFromMemory Lib "Squall"  Alias "SQUALL_Sample_LoadFromMemory" (MemoryPtr As Any Ptr, MemorySize As Integer, NewMemory As Integer,  Default As squall_sample_default_t Ptr) As Integer

'-----------------------------------------------------------------------------
'   
'      :  *
'     :  *
'-----------------------------------------------------------------------------
Declare Sub SQUALL_Sample_UnloadAll Lib "Squall"  Alias "SQUALL_Sample_UnloadAll" ()

'-----------------------------------------------------------------------------
'   
'      :  SampleID -   
'     :  *
'-----------------------------------------------------------------------------
Declare Sub SQUALL_Sample_Unload Lib "Squall"  Alias "SQUALL_Sample_Unload" (SampleID As Integer)

'-----------------------------------------------------------------------------
'       
'      :  SampleID -   
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_GetFileLength Lib "Squall"  Alias "SQUALL_Sample_GetFileLength" (SampleID As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  SampleID -   
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_GetFileLengthMs Lib "Squall"  Alias "SQUALL_Sample_GetFileLengthMs" (SampleID As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  SampleID -   
'     :  ,       0,
'                 ,     
'                      
'                
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_GetFileFrequency Lib "Squall"  Alias "SQUALL_Sample_GetFileFrequency" (SampleID As Integer) As Integer

'-----------------------------------------------------------------------------
'      
'      :  SampleID -   
'                Default  -        
'                             
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_SetDefault Lib "Squall"  Alias "SQUALL_Sample_SetDefault" (SampleID As Integer, Default As squall_sample_default_t Ptr) As Integer

'-----------------------------------------------------------------------------
'      
'      :  SampleID -   
'                Default  -        
'                                
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_GetDefault Lib "Squall"  Alias "SQUALL_Sample_GetDefault" (SampleID As Integer, Default As squall_sample_default_t Ptr) As Integer

'-----------------------------------------------------------------------------
'        , 
'     
'      :  SampleID       -   
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_Play Lib "Squall"  Alias "SQUALL_Sample_Play" (SampleID As Integer , Loop_ As Integer , Group As Integer ,  Start As Integer) As Integer


'-----------------------------------------------------------------------------
'        , 
'     
'      :  SampleID       -   
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Priority       -     ,
'                                       
'                                   0  65535
'                Volume         -     ,
'                                   ,   
'                                      0  100
'                Frequency      -     ,
'                                       
'                                   100  1000000000
'                Pan            -     ,
'                                       
'                                   0  100
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_PlayEx Lib "Squall"  Alias "SQUALL_Sample_PlayEx" (SampleID As Integer , Loop_ As Integer , Group As Integer ,  Start As Integer, Priority As Integer, Volume As Integer, Frequency As Integer, Pan As Integer) As Integer

'-----------------------------------------------------------------------------
'     ()   
'  ,      
'      :  SampleID       -   
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Position       -     c 
'                                    
'                Velocity       -      
'                                   ,    
'                                      ,
'                                        0
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_Play3D Lib "Squall"  Alias "SQUALL_Sample_Play3D" (SampleID As Integer , Loop_ As Integer , Group As Integer ,  Start As Integer, Position As Single Ptr, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     ()   
'  
'      :  SampleID       -   
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Position       -     c 
'                                    
'                Velocity       -      
'                                   ,    
'                                      ,
'                                        0
'                Priority       -     ,
'                                       
'                                   0  65535
'                Volume         -     ,
'                                   ,   
'                                      0  100
'                Frequency      -     ,
'                                       
'                                   100  1000000000
'                MinDist        -     
'                                  ,     
'                                    0.01f  1000000000.0f
'                MaxDist        -     
'                                  ,     
'                                    0.01f  1000000000.0f
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_Play3DEx Lib "Squall"  Alias "SQUALL_Sample_Play3DEx" (SampleID As Integer , Loop_ As Integer , Group As Integer ,  Start As Integer, Position As Single Ptr, Velocity As Single Ptr, Priority As Integer, Volume As Integer, Frequency As Integer, MinDist As Single, MaxDist As Single) As Integer

'-----------------------------------------------------------------------------
' /      
'      :  SampleID -     
'                Pause    -   / ,  
'                              :
'                            true   -  
'                            false  -  
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_Pause Lib "Squall"  Alias "SQUALL_Sample_Pause" (SampleID As Integer , Pause_ As Integer) As Integer

'-----------------------------------------------------------------------------
'       
'      :  SampleID -   
'     :  ,       0,
'                 ,     
'-----------------------------------------------------------------------------
Declare Function SQUALL_Sample_Stop Lib "Squall"  Alias "SQUALL_Sample_Stop" (SampleID As Integer) As Integer

'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'                     
'''''''''''''''''''''''''''''''''''''''/
'''''''''''''''''''''''''''''''''''''''/
'-----------------------------------------------------------------------------
'        , 
'     
'      :  SampleGroupID  -    
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_SampleGroup_Play Lib "Squall"  Alias "SQUALL_SampleGroup_Play" (SoundGroupID As Integer, Loop_ As Integer, Group As Integer, Start As Integer) As Integer

'-----------------------------------------------------------------------------
'        
'      :  SampleGroupID  -    
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Priority       -     ,
'                                       
'                                   0  65535
'                Volume         -     ,
'                                   ,   
'                                      0  100
'                Frequency      -     ,
'                                       
'                                   100  1000000000
'                Pan            -     ,
'                                       
'                                   0  100
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_SampleGroup_PlayEx Lib "Squall"  Alias "SQUALL_SampleGroup_PlayEx" (SoundGroupID As Integer, Loop_ As Integer, Group As Integer, Start As Integer, Priority As Integer, Volume As Integer, Frequency As Integer, Pan As Integer) As Integer

'-----------------------------------------------------------------------------
'     ()   
'   ,      
'      :  SampleGroupID  -    
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Position       -     c 
'                                    
'                Velocity       -      
'                                   ,    
'                                      ,
'                                        0
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_SampleGroup_Play3D Lib "Squall"  Alias "SQUALL_SampleGroup_Play3D" (SoundGroupID As Integer, Loop_ As Integer, Group As Integer, Start As Integer, Position As Single Ptr, Velocity As Single Ptr) As Integer

'-----------------------------------------------------------------------------
'     ()   
'   
'      :  SampleGroupID  -    
'                Loop           -    , 
'                                     :
'                                  true  -     
'                                           
'                                  false -     
'                ChannelGroupID -      
'                                  ,     0
'                                       
'                                  .
'                Start          -       
'                                  ,    
'                                  :
'                                  true  -     
'                                            
'                                  false -     ,
'                                               
'                                             
'                                           SQUALL_Channel_Start()
'                Position       -     c 
'                                    
'                Velocity       -      
'                                   ,    
'                                      ,
'                                        0
'                Priority       -     ,
'                                       
'                                   0  65535
'                Volume         -     ,
'                                   ,   
'                                      0  100
'                Frequency      -     ,
'                                       
'                                   100  1000000000
'                MinDist        -     
'                                  ,     
'                                    0.01f  1000000000.0f
'                MaxDist        -     
'                                  ,     
'                                    0.01f  1000000000.0f
'     :  ,       0,
'                 ,     
'                      
'                  
'-----------------------------------------------------------------------------
Declare Function SQUALL_SampleGroup_Play3DEx Lib "Squall"  Alias "SQUALL_SampleGroup_Play3DEx" (SoundGroupID As Integer, Loop_ As Integer, Group As Integer, Start As Integer, Position As Single Ptr, Velocity As Single Ptr, Priority As Integer, Volume As Integer, Frequency As Integer, MinDist As Single, MaxDist As Single) As Integer

End Extern
